Index: trunk/kernel/devices/dev_ioc.h
===================================================================
--- trunk/kernel/devices/dev_ioc.h	(revision 690)
+++ trunk/kernel/devices/dev_ioc.h	(revision 1)
@@ -2,5 +2,5 @@
  * dev_ioc.h - IOC (Block Device Controler) generic device API definition.
  * 
- * Author  Alain Greiner    (2016,2017,2018,2019,2020)
+ * Author  Alain Greiner    (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -25,10 +25,9 @@
 #define _DEV_IOC_H
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
+#include <hal_types.h>
 
 /****  Forward declarations  ****/
 
-struct chdev_s;
+struct device_s;
 
 /*****************************************************************************************
@@ -38,30 +37,27 @@
  * magnetic hard disk or a SD card, that can store blocks of data in a linear array
  * of sectors indexed by a simple lba (logic block address).
+ * It supports two command types:
+ * - READ  : move a given number of contiguous blocks from device to a memory buffer.
+ * - WRITE : move a given number of contiguous blocks from a memory buffer to device.
  *
- * It supports four command types:
- * - READ       : move blocks from device to memory, with a descheduling policy.
- * - WRITE      : move blocks from memory to device, with a descheduling policy.
- * - SYNC_READ  : move blocks from device to memory, with a busy waiting policy.
- * - SYNC_WRITE : move blocks from memory to device, with a busy waiting policy.
- *
- * For the READ or WRITE operations, the client thread is descheduled, and the work
- * is done by the server thread associated to the IOC device:
- * The client thread calls the dev_ioc_move_data() kernel functions that (i) registers
- * the command in the client thread descriptor, (ii) registers the client thread 
- * in the IOC device waiting queue, and (iii) blocks on the THREAD_BLOCKED_IO condition
- * and deschedules.
- * The server thread attached to the IOC device descriptor handles the commands
- * registered in the waiting queue, calling the IOC driver function.
- * Most IOC device implementations have a DMA capability, but some implementations,
- * such as the RDK (Ram Disk) implementation does not use DMA.
- * When the server thread completes an I/O operation, it reactivates the client thread.
- *
- * The SYNC_READ and SYNC_WRITE operations are used by the kernel in the initialisation
- * phase, to update the FAT (both the FAT mapper and the FAT on IOC device), or to update
- * a directory on IOC device when a new file is created. 
- * These synchronous operations do not not use the IOC device waiting queue, 
- * the server thread, and the IOC IRQ. The client thread does not deschedules:
- * it registers the command in the thread descriptor, calls directly the IOC driver,
- * and uses a busy-waiting policy to poll the IOC device status.
+ * An I/O operation requires dynamic ressource allocation, and is always blocking for
+ * the client thread. The general scenario is detailed below.
+ * A) the client thread start the I/O operation, by calling the dev_ioc_read()
+ *    or the dev_ioc_write() kernel functions that perform the following actions: 
+ *    1) it get a free WTI mailbox from the client cluster WTI allocator.
+ *    2) it enables the WTI IRQ on the client cluster ICU and update interrupt vector.
+ *    3) it access the PIC to link the WTI mailbox to the IOC IRQ.
+ *    4) it builds the command descriptor.
+ *    5) it registers in the IOCdevice waiting queue. 
+ *    6) itblock on the THREAD_BLOCKED_IO condition and deschedule.
+ * B) The server thread attached to the IOC device descriptor handles the commands
+ *    registered in the waiting queue, calling the IOC driver function.
+ *    Most hardware implementation have a DMA capability, but some implementations,
+ *    such as the RDK (Ram Disk) implementation does not use DMA.
+ * C) The ISR signaling the I/O operation completion reactivates the client thread,
+ *    that releases the allocated resources:
+ *    1) access the PIC to unlink the IOC IRQ.
+ *    2) disable the WTI IRQ in the client cluster ICU and update interrupt vector.
+ *    3) release the WTI mailbox to the client cluster WTI allocator.
  *****************************************************************************************/
 
@@ -82,5 +78,5 @@
  *****************************************************************************************/
 
-typedef enum
+enum ioc_impl_e
 {
     IMPL_IOC_BDV =   0,     
@@ -93,23 +89,14 @@
 
 /******************************************************************************************
- * This structure defines the IOC command for all drivers implementing the IOC device.
+ * This defines the (implementation independant)  command passed to the driver.
  *****************************************************************************************/
-
-typedef enum
-{
-    IOC_READ       = 0,
-    IOC_WRITE      = 1,
-    IOC_SYNC_READ  = 2,
-    IOC_SYNC_WRITE = 3,
-}
-ioc_cmd_type_t;
 
 typedef struct ioc_command_s
 {
-    xptr_t      dev_xp;     /*! extended pointer on IOC device descriptor                */
-    uint32_t    type;       /*! command type above                                       */
+    xptr_t      dev_xp;      /*! extended pointer on device descriptor                    */
+    uint32_t    to_mem;     /*! requested operation (WRITE if zero / READ if non-zero)   */
     uint32_t    lba;        /*! first block index                                        */
     uint32_t    count;      /*! number of blocks                                         */
-    xptr_t      buf_xp;     /*! extended pointer on kernel memory buffer                 */
+    xptr_t      buf_xp;     /*! extended pointer on memory buffer                        */
     uint32_t    error;      /*! operation status (0 if success)                          */
 }
@@ -117,95 +104,68 @@
 
 /******************************************************************************************
- * This function returns a printable string for a IOC command type.
+ * This function completes the IOC device descriptor initialisation,
+ * namely the link with the implementation specific driver.
+ * The func, impl, channel, is_rxt, base, and size fields must be previously initialised.
+ * It calls the specific driver initialisation function, to initialise the hardware
+ * device and the specific data structures when required.
+ * It creates the associated server thread.
+ * It can be executed in another cluster than the cluster containing the device descriptor
+ * or the hardware device itself.
  ******************************************************************************************
- * @ cmd  : command type.
- * @ return pointer on string.
+ * @ xp_dev     : extended pointer on IOC device descriptor.
  *****************************************************************************************/
-char * dev_ioc_cmd_str( ioc_cmd_type_t cmd );
+void dev_ioc_init( xptr_t  xp_dev );
 
 /******************************************************************************************
- * This function completes the IOC chdev descriptor initialisation,
- * namely the link with the implementation specific driver.
- * The func, impl, channel, is_rx, base fields have been previously initialised.
- * It calls the specific driver initialisation function, to initialise the hardware
- * device and the specific data structures when required.
- * It creates the associated server thread and allocates a WTI from local ICU.
- * It must de executed by a local thread.
+ * This blocking function try to tranfer one or several contiguous blocks of data
+ * from the block device to a memory buffer. The corresponding request is actually
+ * registered in the device pending request queue, and the calling thread is descheduled,
+ * waiting on transfer completion. It will be resumed by the IRQ signaling completion.
+ * It must be called in the client cluster.
  ******************************************************************************************
- * @ chdev     : local pointer on IOC chdev descriptor.
+ * @ buffer    : local pointer on target buffer in memory.
+ * @ lba       : first block index on device.
+ * @ count     : number of blocks to transfer.
+ * @ returns 0 if success / returns EINVAL if error.
  *****************************************************************************************/
-void dev_ioc_init( struct chdev_s * chdev );
+error_t dev_ioc_read( char         * buffer,
+                      uint32_t       lba,
+                      uint32_t       count );
 
 /******************************************************************************************
- * This blocking function register an asynchronous READ request : move <count> contiguous
- * blocks from the block device, starting from block defined by the <lba> argument, to a
- * kernel buffer defined by the <buffer_xp> argument.
- * It register the request in the client thread descriptor, it register the client thread
- * in the IOC device queue, it blocks on the THREAD_BLOCKED_IO condition, and deschedules.
- * It will be reactivated by the DEV server thread when the transfer is completed.
- * It can be executed by a thread running in any cluster.
+ * This blocking function try to tranfer one or several contiguous blocks of data
+ * from a memory buffer to the block device. The corresponding request is actually
+ * registered in the device pending request queue, and the calling thread is descheduled,
+ * waiting on transfer completion. It will be resumed by the IRQ signaling completion.
+ * It must be called in the client cluster.
  ******************************************************************************************
- * @ buffer_xp : extended pointer on kernel buffer in memory (must be block aligned).
+ * @ buffer    : local pointer on source buffer in memory.
  * @ lba       : first block index on device.
  * @ count     : number of blocks to transfer.
- * @ returns 0 if success / returns -1 if error.
+ * @ returns 0 if success / returns EINVAL if error.
  *****************************************************************************************/
-error_t dev_ioc_read( xptr_t    buffer_xp,
-                      uint32_t  lba,
-                      uint32_t  count );
+error_t dev_ioc_write( char         * buffer,
+                       uint32_t       lba,
+                       uint32_t       count );
 
 /******************************************************************************************
- * This blocking function register an asynchronous WRITE request : move <count> contiguous
- * blocks from a kernel buffer defined by the <buffer_xp> argument to the block device,
- * starting from block defined by the <lba> argument.
- * It register the request in the client thread descriptor, it register the client thread
- * in the IOC device queue, it blocks on the THREAD_BLOCKED_IO condition, and deschedules.
- * It will be reactivated by the DEV server thread when the transfer is completed.
- * It can be executed by a thread running in any cluster.
+ * This function is executed by the server thread associated to the IOC device descriptor. 
+ * This thread is created and activated by the dev_ioc_init() function.
+ * It executes an infinite loop to handle sequencially all commands registered 
+ * by the client threads in the device waiting queue, calling the driver CMD function. 
+ *  
+ * - If the peripheral can only handle one single command, the driver block the server 
+ *   thread on the THREAD_BLOCKED_DEV_ISR condition, waiting I/O operation conmpletion.
+ *   The server thread must be reacticated by the driver ISR function.
+ * - If the peripheral can handle several commands in parallel (AHCI is an example), the
+ *   driver does not block the server thread (it is only descheduled if the number of
+ *   commands exceeeds the max number of parallel commands supported by the peripheral.
+ *
+ * When the waiting queue is empty, the server thread blocks on the THREAD_BLOCKED_CMD
+ * condition and deschedule. It is re-activated by a client thread registering a command.
  ******************************************************************************************
- * @ buffer_xp : extended pointer on kernel buffer in memory (must be block aligned).
- * @ lba       : first block index on device.
- * @ count     : number of blocks to transfer.
- * @ returns 0 if success / returns -1 if error.
+ * @ dev     : local pointer on IOC device descriptor.
  *****************************************************************************************/
-error_t dev_ioc_write( xptr_t    buffer_xp,
-                       uint32_t  lba,
-                       uint32_t  count );
-
-/******************************************************************************************
- * This blocking function executes a synchronous SYNC_READ request : it moves <count>
- * contiguous blocks of data from the block device, starting from block defined by the
- * <lba> argument to a kernel memory buffer, defined by the <buffer_xp> argument. 
- * The request is registered in the calling thread descriptor, but the client thread calls
- * directly the driver cmd function, that is also a blocking function returning only
- * when the transfer is completed.
- * It can be executed by a thread running in any cluster.
- ******************************************************************************************
- * @ buffer_xp : extended pointer on kernel buffer in memory (must be block aligned).
- * @ lba       : first block index on device.
- * @ count     : number of blocks to transfer.
- * @ returns 0 if success / returns -1 if error.
- *****************************************************************************************/
-error_t dev_ioc_sync_read( xptr_t    buffer_xp,
-                           uint32_t  lba,
-                           uint32_t  count );
-
-/******************************************************************************************
- * This blocking function executes a synchronous SYNC_WRITE request : it moves <count>
- * contiguous blocks of data from a kernel memory buffer, defined by the <buffer_xp>
- * argument to the block device, starting from block defined by the <lba> argument. 
- * The request is registered in the calling thread descriptor, but the client thread calls
- * directly the driver cmd() function, that is also a blocking function returning only
- * when the transfer is completed.
- * It can be executed by a thread running in any cluster.
- ******************************************************************************************
- * @ buffer_xp : extended pointer on kernel buffer in memory (must be block aligned).
- * @ lba       : first block index on device.
- * @ count     : number of blocks to transfer.
- * @ returns 0 if success / returns -1 if error.
- *****************************************************************************************/
-error_t dev_ioc_sync_write( xptr_t    buffer_xp,
-                            uint32_t  lba,
-                            uint32_t  count );
+void dev_ioc_server( struct device_s * dev );
 
 #endif	/* _DEV_IOC_H */
Index: trunk/kernel/devices/dev_iox.c
===================================================================
--- trunk/kernel/devices/dev_iox.c	(revision 1)
+++ trunk/kernel/devices/dev_iox.c	(revision 1)
@@ -0,0 +1,181 @@
+/*
+ * dev_iox.c - IOX (bridge to external I/O) generic device API implementation.
+ *
+ * Authors   Alain Greiner  (2017)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTIOXLAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <almos_config.h>
+#include <hal_types.h>
+#include <hal_special.h>
+#include <remote_spinlock.h>
+#include <device.h>
+#include <printk.h>
+#include <soclib_iob.h>
+#include <dev_iox.h>
+
+//////////////////////////////////
+void dev_iox_init( xptr_t dev_xp )
+{
+    // get IOX device descriptor cluster and local pointer
+    cxy_t      dev_cxy = GET_CXY( dev_xp );
+    device_t * dev_ptr = (device_t *)GET_PTR( dev_xp );
+
+    // get implementation from device descriptor
+    uint32_t  impl = hal_remote_lw( XPTR( dev_cxy , &dev_ptr->impl ) );
+
+    // call driver init function
+    if( impl == IMPL_IOX_IOB )
+    {
+        soclib_iob_init( dev_xp );
+    }
+    else
+    {
+        printk("\n[PANIC] in %s: undefined IOX device implementation\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+}
+
+//////////////////////////////////////////
+void dev_iox_iommu_enable( xptr_t dev_xp )
+{
+    // get IOX device descriptor cluster and local pointer
+    cxy_t      dev_cxy = GET_CXY( dev_xp );
+    device_t * dev_ptr = (device_t *)GET_PTR( dev_xp );
+
+    // get implementation from device descriptor
+    uint32_t  impl = hal_remote_lw( XPTR( dev_cxy , &dev_ptr->impl ) );
+
+    // call driver function
+    if( impl == IMPL_IOX_IOB )
+    {
+        remote_spinlock_lock( XPTR( dev_cxy , &dev_ptr->wait_lock ) );
+        soclib_iob_set_active( dev_xp , 1 );
+        remote_spinlock_unlock( XPTR( dev_cxy , &dev_ptr->wait_lock ) );
+    }
+    else
+    {
+        printk("\n[PANIC] in %s: undefined IOX device implementation\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+}
+
+///////////////////////////////////////////
+void dev_iox_iommu_disable( xptr_t dev_xp )
+{
+    // get IOX device descriptor cluster and local pointer
+    cxy_t      dev_cxy = GET_CXY( dev_xp );
+    device_t * dev_ptr = (device_t *)GET_PTR( dev_xp );
+
+    // get implementation from device descriptor
+    uint32_t  impl = hal_remote_lw( XPTR( dev_cxy , &dev_ptr->impl ) );
+
+    // call driver function
+    if( impl == IMPL_IOX_IOB )
+    {
+        remote_spinlock_lock( XPTR( dev_cxy , &dev_ptr->wait_lock ) );
+        soclib_iob_set_active( dev_xp , 0 );
+        remote_spinlock_unlock( XPTR( dev_cxy , &dev_ptr->wait_lock ) );
+    }
+    else
+    {
+        printk("\n[PANIC] in %s: undefined IOX device implementation\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+}
+
+////////////////////////////////////////
+void dev_iox_set_ptpr( xptr_t    dev_xp,
+                       uint32_t  wdata )
+{
+    // get IOX device descriptor cluster and local pointer
+    cxy_t      dev_cxy = GET_CXY( dev_xp );
+    device_t * dev_ptr = (device_t *)GET_PTR( dev_xp );
+
+    // get implementation from device descriptor
+    uint32_t  impl = hal_remote_lw( XPTR( dev_cxy , &dev_ptr->impl ) );
+
+    // call driver function
+    if( impl == IMPL_IOX_IOB )
+    {
+        remote_spinlock_lock( XPTR( dev_cxy , &dev_ptr->wait_lock ) );
+        soclib_iob_set_ptpr( dev_xp , wdata );
+        remote_spinlock_unlock( XPTR( dev_cxy , &dev_ptr->wait_lock ) );
+    }
+    else
+    {
+        printk("\n[PANIC] in %s: undefined IOX device implementation\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+}
+                        
+////////////////////////////////////////
+void dev_iox_inval_page( xptr_t  dev_xp,
+                         vpn_t   vpn )
+{
+    // get IOX device descriptor cluster and local pointer
+    cxy_t      dev_cxy = GET_CXY( dev_xp );
+    device_t * dev_ptr = (device_t *)GET_PTR( dev_xp );
+
+    // get implementation from device descriptor
+    uint32_t  impl = hal_remote_lw( XPTR( dev_cxy , &dev_ptr->impl ) );
+
+    // call driver function
+    if( impl == IMPL_IOX_IOB )
+    {
+        remote_spinlock_lock( XPTR( dev_cxy , &dev_ptr->wait_lock ) );
+        soclib_iob_inval_page( dev_xp , vpn );
+        remote_spinlock_unlock( XPTR( dev_cxy , &dev_ptr->wait_lock ) );
+    }
+    else
+    {
+        printk("\n[PANIC] in %s: undefined IOX device implementation\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+}
+
+///////////////////////////////////////////
+void dev_iox_get_status( xptr_t     dev_xp,
+                         uint32_t * error,
+                         uint32_t * bvar,
+                         uint32_t * srcid )
+{
+    // get IOX device descriptor cluster and local pointer
+    cxy_t      dev_cxy = GET_CXY( dev_xp );
+    device_t * dev_ptr = (device_t *)GET_PTR( dev_xp );
+
+    // get implementation from device descriptor
+    uint32_t  impl = hal_remote_lw( XPTR( dev_cxy , &dev_ptr->impl ) );
+
+    // call driver function
+    if( impl == IMPL_IOX_IOB )
+    {
+        remote_spinlock_lock( XPTR( dev_cxy , &dev_ptr->wait_lock ) );
+        *error = soclib_iob_get_error( dev_xp );
+        *srcid = soclib_iob_get_srcid( dev_xp );
+        *bvar  = soclib_iob_get_bvar( dev_xp );
+        remote_spinlock_unlock( XPTR( dev_cxy , &dev_ptr->wait_lock ) );
+    }
+    else
+    {
+        printk("\n[PANIC] in %s: undefined IOX device implementation\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+}
+
Index: trunk/kernel/devices/dev_iox.h
===================================================================
--- trunk/kernel/devices/dev_iox.h	(revision 1)
+++ trunk/kernel/devices/dev_iox.h	(revision 1)
@@ -0,0 +1,109 @@
+/*
+ * dev_iox.h - IOX (bridge to external I/O) generic device API.
+ *
+ * Authors   Alain Greiner  (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTIOXLAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _DEV_IOX_H_
+#define _DEV_IOX_H_
+
+#include <almos_config.h>
+#include <hal_types.h>
+#include <spinlock.h>
+
+/*****************************************************************************************
+ *     Generic IOX (bridge to external IO peripherals) definition.
+ *
+ * The IOX device is used to access external peripherals. It implements an IO-MMU service 
+ * for DMA transactions launched by DMA capable external peripherals.
+ * This IOX peripheral is acting as a dynamically configurable bridge, used for others 
+ * I/O operations. Therefore, ALMOS-MKH does not use the IOX device waiting queue,
+ * and calls directly the IOX driver blocking functions, using the device lock to 
+ * get exclusive access to the IOX bridge internal state.
+ ****************************************************************************************/
+ 
+
+/*****************************************************************************************
+ * This enum defines the various implementations of the IOX generic device.
+ * This array must be kept consistent with the define in arch_info.h file
+ ****************************************************************************************/
+
+enum iox_impl_e
+{
+    IMPL_IOX_IOB =   0,         /* vci_iob component used in TSAR                       */
+    IMPL_IOX_I86 =   1,         /* TBD                                                  */
+}
+iox_impl_t;
+
+/*****************************************************************************************
+ * This function initializes the IOX device descriptor with IOMMU disabled.
+ *****************************************************************************************
+ * @ dev_xp     : extended pointer on IOX device descriptor.
+ ****************************************************************************************/
+void dev_iox_init( xptr_t dev_xp );
+
+/*****************************************************************************************
+ * This function activates the IOMMU for the IOX device identified by its
+ * extended pointer.
+ *****************************************************************************************
+ * @ dev_xp   : extended pointer on IOX device descriptor.
+ ****************************************************************************************/
+void dev_iox_iommu_enable( xptr_t dev_xp );
+
+/*****************************************************************************************
+ * This function desactivates the IO-MMU for the IOX device identified by its
+ * extended pointer.
+ *****************************************************************************************
+ * @ dev_xp   : extended pointer on IOX device descriptor.
+ ****************************************************************************************/
+void dev_iox_iommu_disable( xptr_t dev_xp );
+
+/*****************************************************************************************
+ * This function set a new value in the IO-MMU PTPR register.
+ *****************************************************************************************
+ * @ dev_xp   : extended pointer on IOX device descriptor.
+ * @ wdata    : value to be written in PTPR register.
+ ****************************************************************************************/
+void dev_iox_set_ptpr( xptr_t    dev_xp,
+                       uint32_t  wdata );
+                        
+/*****************************************************************************************
+ * This function invalidates an IOMMU TLB entry identified by its vpn.
+ *****************************************************************************************
+ * @ dev_xp   : extended pointer on IOX device descriptor.
+ * @ vpn      : virtual page number in IO virtual space.
+ ****************************************************************************************/
+void dev_iox_inval_page( xptr_t  dev_xp,
+                         vpn_t   vpn );
+
+/*****************************************************************************************
+ * This function return informations relative to an error reported by the IOMMU.
+ *****************************************************************************************
+ * @ dev_xp   : extended pointer on IOX device descriptor.
+ * @ error    : [out] pointer on buffer for erro type.
+ * @ bvar     : [out] pointer on buffer for bad virtual address.
+ * @ srcid    : [out] pointer on buffer for faulty peripheral index.
+ ****************************************************************************************/
+void dev_iox_get_status( xptr_t     dev_xp,
+                         uint32_t * error,
+                         uint32_t * bvar,
+                         uint32_t * srcid );
+
+#endif  /* _DEV_IOX_H_ */
